# Room Setup

## Video Tutorial

<iframe src="https://www.youtube-nocookie.com/embed/8t66SH6ZbEE?si=-yEmwCJpE2mvjg6Z" title="YouTube video player" frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share" allowfullscreen></iframe>

## Introduction

In order to be able to add entities into your virtual home, you have to configure the rooms first. Otherwise you will get an error message like on the image below.

![Error adding Entity outside of a Room](/img/room-setup-1.png)

## Adding a Room

1. Open the Menu
2. Click on the 3rd button from the top to open the Room Setup Panel
3. Click on the **Room** button to open the Rooms tab.

![Panel where a room can be added](/img/room-setup-2.png)

4. Click on the + button to add a new room.
5. Enter the name of the room
6. Click in a corner on the floor to add the initial corner

![Corner of Room](/img/room-setup-3.png)

7. Adjust the height of the room by moving the upper circle until it matches the height of the room
8. Click on another corner on the ceiling to add the second corner
9. Continue adding corners to the ceiling until the room is fully enclosed
10. Click on the **Save** button to save the room

![Room fully configured](/img/room-setup-4.png)

## Reference Point
 
The reference point will allow you to fix the positioning of your rooms in case they got changed after you redid your boundary or similar. Here the steps:

1. Go to the Overview tab of the Room menu
2. Click on the edit button (pen icon)
3. Locate and move the Reference point to a desired location, for example an image hanging on the wall or a window
4. Press the save button

The result should look something like this:

![Reference Point next to Image](/img/reference-point.png)

In case that your room now has moved after starting the app again, you can do the following to fix the alignment again:

1. Go to the Overview tab of the Room menu
2. Click on the fix button (band aid icon)
3. Move the Reference Point back to it's original position
4. Press the save button

This should result in the room being in the right spot again. In case there is something wrong at the moment, restart the app and everything should be back to normal.